#!/usr/bin/perl -T

#===========================================================================
# ezmlm-web.cgi - version 1.0 - 01/08/1998
#
# Copyright (C) 1998, Guy Antony Halse, All Rights Reserved.
#
# This program is free for non-commercial use; you can redistribute it and/or
# modify it under the terms of the GNU General Public License (version 2 or
# later) as published by the Free Software Foundation. This program is
# distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
# without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# Please send any bug reports or comments to guy-ezmlm@rucus.ru.ac.za
# ==========================================================================
# Changelog moved to file CHANGES with this distribution.
# ==========================================================================

# Suid stuff requires a secure path. Ensure that the following can be found;
# ezmlm-make, ezmlm-list, ezmlm-sub, ezmlm-unsub, mv, rm
$ENV{'PATH'} = '/bin:/usr/bin:/usr/local/bin';

# We run suid so we can't use $ENV{'HOME'} and $ENV{'USER'} to determine the
# user. :( Don't alter this line unless you are _sure_ you have to.
@tmp = getpwuid($>); $USER=$tmp[0]; $HOME_DIR=$tmp[7];

# Where do we store lists on this server ... Try "$HOME_DIR/lists". 
# This directory will automatically be created if needed.
$LIST_DIR = "$HOME_DIR/lists";

# Default domain name to use if one isn't supplied. This is mainly used to 
# determine if we are using a virtual host, and to allow the user to enter
# "user@" instead of the full email address to add a local subscriber.
open( DEFAULT_HOST_FILE, "</var/qmail/control/me" ) || die "Can't open /var/qmail/control/me: $!\n";
$DEFAULT_HOST = <DEFAULT_HOST_FILE>;
close( DEFAULT_HOST_FILE );

# Where is the qmail virtual domains file kept on this system?
$VIRTUAL_DOMAINS = '/var/qmail/control/virtualdomains';

# Safe list deletion? 
# 0 = move list to .list and the .qmails to deleted.qmail/. Recoverable :)
# 1 = allow user to delete list completely. No backup, therefore no recovery.
$UNSAFE_RM = 0;

# What switches to we want ezmlm-web to have on as default. The ones that 
# ezmlm-make uses as builtin defaults are 'aip'. Available ones are 
# 'adfgiklmnpqrstu5'. See the ezmlm-make(1) man page for more details.
$DEFAULT_OPTIONS = 'aip5';

# ==========================================================================
# User configurable stuff ends ... Don't alter anything below this line.
# ==========================================================================
require 5.001; # Check the perl version ...

# Set up a new CGI query ...
use CGI;
use CGI::Carp qw(fatalsToBrowser);
$q = new CGI;

# Allow suid wrapper to over-ride default list directory ...
use Getopt::Std;
getopts('d:');
if(defined($opt_d)) {
   $LIST_DIR = $1 if ($opt_d =~ /^([-\@\w.\/]+)$/);
}

# Untaint form input ...
&untaint;

# Print header on every page ...
print $q->header;
print $q->start_html(-title=>'EZ Mailing List Manager', -author=>'guy-ezmlm@rucus.ru.ac.za', -BGCOLOR=>'#9040D0', -LINK=>'#2000C0', -expires=>'now');
print <<'EOM';
   <CENTER><TABLE BORDER=1 ALIGN=CENTER><TR><TD>
   <FONT SIZE=+3 COLOR=#000080><STRONG>E Z Mailing List Manager</STRONG></FONT>
   </TD></TR></TABLE></CENTER>
EOM

# This is where we decide what to do, depending on the form state and the
# users chosen course of action ...
unless (defined($q->param('state'))) {
   # Default action. Present a list of available lists to the user ...
   &select_list; 

} elsif ($q->param('state') eq 'select') {
   # User selects an action to perorm on a list ...
   
   if ($q->param('action') eq '[Create]') { # Create a new list ...
      &allow_create_list;
   } elsif (defined($q->param('list'))) {
      if ($q->param('action') eq '[Edit]') { # Edit an existing list ...
         &display_list;
      } elsif ($q->param('action') eq '[Delete]') { # Delete a list ...
         &confirm_delete;
      }
   } else {
      &select_list; # NOP - Blank input ...
   }
   
} elsif ($q->param('state') eq 'edit') {
   # User chooses to edit a list
   
   my($list); $list = $LIST_DIR . '/' . $q->param('list'); 
   if ($q->param('action') eq '[Delete Address]') { # Delete a subscriber ...
      &delete_address($list);
      &display_list;
   
   } elsif ($q->param('action') eq '[Add Address]') { # Add a subscriber ...
      &add_address($list);
      &display_list;
   
   } elsif ($q->param('action') eq '[Moderators]') { # Edit the moderators ...
      &moderators;

   } elsif ($q->param('action') eq '[Blacklist]') { # Edit the blacklist ...
      &blacklist;
   
   } elsif ($q->param('action') eq '[Digest]') { # Edit the digest subscribers ...
      &digest;
      
   } elsif ($q->param('action') eq '[Configuration]') { # Edit the config ...
      &list_config;

   } elsif ($q->param('action') eq '[Create Config]') { # Try and create conf file ...
      &create_config;
      &display_list;
       
   } else { # Cancel - Return a screen ...
      &select_list;
   }

} elsif ($q->param('state') eq 'moderators' || $q->param('state') eq 'blacklist' || $q->param('state') eq 'digest') {
   # User edits moderators || blacklist || digest ...

   my($list); 
   # Which list directory are we using ...
   if($q->param('state') eq 'moderators') {
      $list = $LIST_DIR . '/' . $q->param('list') . '/mod'; 
   } elsif($q->param('state') eq 'blacklist' ) {
      $list = $LIST_DIR . '/' . $q->param('list') . '/blacklist'; 
   } else {
      $list = $LIST_DIR . '/' . $q->param('list') . '/digest'; 
   }
   
   if ($q->param('action') eq '[Delete Address]') { # Delete a subscriber ...
      &delete_address($list);
      if ($q->param('state') eq 'moderators') { &moderators; } elsif ($q->param('state') eq 'blacklist') {  &blacklist; } else { &digest; }

   } elsif ($q->param('action') eq '[Add Address]') { # Add a subscriber ...
      &add_address($list);
      if ($q->param('state') eq 'moderators') { &moderators; } elsif ($q->param('state') eq 'blacklist') {  &blacklist; } else { &digest; }

   } else { # Cancel - Return to the list ...
      &display_list;
   }

} elsif ($q->param('state') eq 'confirm_delete') {
   # User wants to delete a list ...
   
   &delete_list if($q->param('confirm') eq '[Yes]'); # Do it ...
   $q->delete_all;
   &select_list;

} elsif ($q->param('state') eq 'create') {
   # User wants to create a list ...

   if ($q->param('action') eq '[Create List]') {
      if (&create_list) { # Return if list creation is unsuccessful ...
         &allow_create_list;
      } else {
         &select_list; # Else choose a list ...
      }
   
   } else { # Cancel ...
      &select_list;
   }
   
} elsif ($q->param('state') eq 'configuration') {
   # User updates configuration ...
   
   if ($q->param('action') eq '[Update Configuration]') { # Save current settings ...
      &update_config;
      &display_list;
      
   } elsif ($q->param('action') eq '[Edit Texts]') { # Edit DIR/text ...
      &list_text;
   
   } else { # Cancel - Return to list editing screen ...
      &display_list;
   }

} elsif ($q->param('state') eq 'list_text') {
   # User wants to edit texts associated with the list ...
   
   if ($q->param('action') eq '[Edit File]') {
      &edit_text;  
   } else {
      &list_config; # Cancel ...
   }

} elsif ($q->param('state') eq 'edit_text') {   
   # User wants to save a new version of something in DIR/text ...
   
   &save_text if ($q->param('action') eq '[Save File]');
   &list_text;
   
} else {
   print '<H2 ALIGN=CENTER>Action not yet implemented</H2><HR ALIGN=center WIDTH=25%>';
} 

# Print HTML footer and exit :) ...
print <<'EOM';
   <HR><FONT SIZE=-2><A HREF=http://www.ezmlm.org/>ezmlm</A> web interface (v1.0) by
   <A HREF=http://www.rucus.ru.ac.za/~guy/>Guy Antony Halse</A>
   (<A HREF=MailTo:guy-ezmlm@rucus.ru.ac.za>guy-ezmlm@rucus.ru.ac.za</A>)</FONT><HR>
EOM
print $q->end_html;
exit;

# =========================================================================

sub select_list {
   # List all mailing lists (sub directories) in the list directory.
   # Allow the user to choose a course of action; either editing an existing
   # list, creating a new one, or deleting an old one.

   my (@lists, @files, $i);

   # Read the list directory for mailing lists.
   opendir DIR, $LIST_DIR || die "Unable to read $LIST_DIR: $!";
   @files = grep !/^\./, readdir DIR; 
   closedir DIR;

   # Check that they actually are lists ...
   foreach $i (0 .. $#files) {
      $lists[$#lists + 1] = $files[$i] if (-e "$LIST_DIR/$files[$i]/lock");
   }

   # Print a form
   $q->delete_all;
   print $q->startform;
   print $q->hidden(-name=>'state', -default=>'select');
   print '<CENTER><TABLE BORDER="0" CELLPADDING="10"><TR><TD ALIGN="center" VALIGN="top" ROWSPAN="2">';
   print $q->scrolling_list(-name=>'list', -values=>\@lists) if defined(@lists);
 
   print <<'EOM';
      </TD><TD ALIGN="left" VALIGN="top">
      <UL>
      <LI>Choose a mailing list from the selection box or click on [Create].
      <LI>Click on the [Edit] button if you want to edit the selected list.
      <LI>Click on the [Delete] button if you want to delete the selected list.<P>
      </UL>
EOM

   print $q->submit(-name=>'action', -value=>'[Create]'), ' ';
   print $q->submit(-name=>'action', -value=>'[Edit]'), ' ' if(defined(@lists));
   print $q->submit(-name=>'action', -value=>'[Delete]') if(defined(@lists));
   print '</TD></TR><TR><TD> </TD></TR></TABLE></CENTER>';
   print $q->endform;
}

# ------------------------------------------------------------------------

sub confirm_delete {
   # Make sure that the user really does want to delete the list!
   
   # Print a form ...
   $q->delete('state');
   print $q->startform;
   print $q->hidden(-name=>'state', -default=>'confirm_delete');
   print $q->hidden(-name=>'list', -default=>$q->param('list'));
   print '<H2 ALIGN="center">Confirm deletion of ', $q->param('list'), '</H3><BR><CENTER>';
   print $q->submit(-name=>'confirm', -value=>'[No]'), ' ';
   print $q->submit(-name=>'confirm', -value=>'[Yes]'), '</CENTER>';
}

# ------------------------------------------------------------------------

sub display_list {
   # Show a list of subscribers to the user ...

   my ($i, $list, $listaddress, $moderated, @subscribers);
   
   # Work out the address of this list ...
   $list = $LIST_DIR . '/' . $q->param('list');
   $listaddress = &this_listaddress;

   
   # Get a list of subscribers from ezmlm ...
   @subscribers = sort `ezmlm-list $list`;
   
   # Print out a form of options ...
   $q->delete('state');                     
   print '<H2 ALIGN=center>Subscribers to ' . $q->param('list') . " ($listaddress)</H2><HR ALIGN=center WIDTH=25%>";
   print $q->startform;
   print '<CENTER><TABLE ALIGN="center" CELLPADDING="10"><TR><TD ROWSPAN="2" VALIGN="top" ALIGN="center">';
   print $q->hidden(-name=>'state', -default=>'edit');
   print $q->hidden(-name=>'list', -default=>$q->param('list'));
   print $q->scrolling_list(-name=>'delsubscriber', -values=>\@subscribers) if defined(@subscribers);
   print '</TD><TD VALIGN="top" ALIGN="left">';
   print $q->submit(-name=>'action', -value=>'[Delete Address]'), '<P>' if defined(@subscribers);
   print $q->textfield(-name=>'addsubscriber', -size=>'40'), '<BR>';
   print $q->submit(-name=>'action', -value=>'[Add Address]'), '<P>';
   print $q->submit(-name=>'action', -value=>'[Moderators]'), ' ' if (-e "$list/modpost" || -e "$list/modsub" || -e "$list/remote");
   print $q->submit(-name=>'action', -value=>'[Blacklist]'), ' ' if (-e "$list/blacklist");
   print $q->submit(-name=>'action', -value=>'[Digest]') if (-e "$list/digest");
   print '<P>';
   print $q->submit(-name=>'action', -value=>'[Configuration]'), ' ' if (-e "$list/config");
   print $q->submit(-name=>'action', -value=>'[Create Config]'), ' ' if (!-e "$list/config");
   print $q->submit(-name=>'action', -value=>'[Select List]');
   print '</TD></TR><TR><TD> </TD></TR></TABLE></CENTER>';
   print $q->endform;          

}

# ------------------------------------------------------------------------

sub delete_list {
   # Delete a list ...

   # Fixes a bug from the previous version ... when the .qmail file has a
   # different name to the list. We use outlocal to handle vhosts ...
   my ($list, $listaddress, $listadd); $list = $LIST_DIR . '/' . $q->param('list');
   if (open(OUTLOCAL, "<$list/outlocal")) {
      chomp($listadd = <OUTLOCAL>);
      close OUTLOCAL;
   } else {
      $listadd = $q->param('list');
   }
   $listaddress = $1 if ($listadd =~ /-?(\w+)$/);
   
   if ($UNSAFE_RM == 0) {
      # This doesn't actually delete anything ... It just moves them so that
      # they don't show up. That way they can always be recovered by a helpful
      # sysadmin should he be in the mood :)
      my ($newfile); $newfile = $LIST_DIR . '/.' . $q->param('list'); 
      rename $list, $newfile || die "Unable to rename list: $!";
      mkdir "$HOME_DIR/deleted.qmail", 0700 if(!-e "$HOME_DIR/deleted.qmail");
      system "mv $HOME_DIR/.qmail-$listaddress $HOME_DIR/deleted.qmail" || die "Unable to move .qmail files: $!"; 
      system "mv $HOME_DIR/.qmail-$listaddress-* $HOME_DIR/deleted.qmail" || die "Unable to move .qmail files: $!"; 
      warn "List '$list' moved (deleted)";   
   } else {
      # This, however, does DELETE the list. I don't like the idea, but I was
      # asked to include support for it so ...
      system "rm -rf $LIST_DIR/" . $q->param('list') || die "Unable to delete list: $!";
      system "rm -f $HOME_DIR/.qmail-$listaddress-*" || die "Unable to delete .qmail files: $!";
      unlink "$HOME_DIR/.qmail-$listaddress" || die "Unable to delete .qmail files $!";
      warn "List '$list' deleted";
   }   
}

# ------------------------------------------------------------------------

sub untaint {
   # Go through all the CGI input and make sure it is not tainted. Log any
   # tainted data that we come accross ... See the perlsec(1) man page ...

   my (@params, $i);
   @params = $q->param;
   
   foreach $i (0 .. $#params) {
      if ($q->param($params[$i]) =~ /^([-\@\w.\/\[\] ]+)$/) {
         $q->param(-name=>$params[$i], -values=>$1);
      } else { warn "Tainted input in '$params[$i]': " . $q->param($params[$i]); }
   } 
}

# ------------------------------------------------------------------------

sub add_address {
   # Add an address to a list ..

   my ($address, $list); ($list) = @_;
   return if ($q->param('addsubscriber') eq '');
   $address = $q->param('addsubscriber');
   $address .= $DEFAULT_HOST if ($q->param('addsubscriber') =~ /\@$/);
   system "ezmlm-sub $list $address" || die "Unable to subscribe to list $list: $!";
   $q->delete('addsubscriber');
}

# ------------------------------------------------------------------------

sub delete_address {
   # Delete an address from a list ...
  
   my ($list); ($list) = @_;
   return if ($q->param('delsubscriber') eq '');
   system "ezmlm-unsub $list " . $q->param('delsubscriber') || die "Unable to unsubscribe from list $list: $!";
   $q->delete('delsubscriber');
}

# ------------------------------------------------------------------------

sub moderators {
   # Deal with list moderatos ....

   my ($i, $list, $listaddress, @subscribers, $moderated);
   
   # Work out the address of this list ...
   $list = $LIST_DIR . '/' . $q->param('list');
   $listaddress = &this_listaddress;

   # Lets know what is moderated :)
   $moderated = '[Posting] ' if(-e ("$list/modpost"));
   $moderated .= '[Subscription] ' if(-e ("$list/modsub"));
   $moderated .= '[Remote Admin]' if(-e ("$list/remote"));


   # Get a list of moderators from ezmlm ...
   @subscribers = sort `ezmlm-list $list/mod`;
   
   # Print out a form of options ...
   $q->delete('state');                     
   print "<H2 ALIGN=center>Moderators for $listaddress</H2><HR ALIGN=center WIDTH=25%>";
   print "<CENTER>$moderated</CENTER><P>";
   print $q->startform;
   print '<CENTER><TABLE ALIGN="center" CELLPADDING="10"><TR><TD ROWSPAN="2" VALIGN="top" ALIGN="center">';
   print $q->hidden(-name=>'state', -default=>'moderators');
   print $q->hidden(-name=>'list', -default=>$q->param('list')), "\n";
   print $q->scrolling_list(-name=>'delsubscriber', -values=>\@subscribers) if defined(@subscribers);
   print '</TD></TR><TR><TD VALIGN="top" ALIGN="left">';
   print $q->submit(-name=>'action', -value=>'[Delete Address]'), '<P>' if defined(@subscribers);
   print $q->textfield(-name=>'addsubscriber', -size=>'40'), '<BR>';
   print $q->submit(-name=>'action', -value=>'[Add Address]'), '<P>';
   print $q->submit(-name=>'action', -value=>'[Subscribers]');
   print '</TD></TR><TR><TD> </TD></TR></TABLE></CENTER>';
   print $q->endform;          

}

# ------------------------------------------------------------------------

sub allow_create_list {
   # Let the user select options for list creation ...
   
   my($username, $hostname, %labels, $j);
   
   # Work out if this user has a virtual host and set input accordingly ...
   open(VD, "<$VIRTUAL_DOMAINS") || warn "Can't read virtual domains file: $!";
   while(<VD>) {
      last if(($hostname) = /(.+?):$USER/);
   }
   close VD;
   
   if(!defined($hostname)) {
      $username = "$USER-";
      $hostname = $DEFAULT_HOST;
   }
                                    
   # Print a form of options ...
   $q->delete_all;
   print '<H2 ALIGN=CENTER>Create A New List</H2><HR ALIGN=center WIDTH=25%>';
   print $q->startform;
   print $q->hidden(-name=>'state', -value=>'create');
   print '<BIG><STRONG>List name: </STRONG></BIG>', $q->textfield(-name=>'list', -size=>'20'), '<P>';
   print '<BIG><STRONG>List address: </STRONG></BIG>', $q->textfield(-name=>'inlocal', -default=>$username, -size=>'10');
   print ' <BIG><STRONG>@</STRONG></BIG> ', $q->textfield(-name=>'inhost', -default=>$hostname, -size=>'30'), '<P>';
   
   # The labels to display against various ezmlm-make command line switches ...
   %labels = (
      a => 'Archived', d => 'Digest', f => 'Prefix', i => 'Indexed',
      l => 'Subscriber List', m => 'Moderated Posting', n => 'Text Editing',
      p => 'Public', r => 'Remote Admin', s => 'Moderated Subscription',
      t => 'Trailer', u => 'User Posting Only', q => 'Service Request Address',
      k => 'Blacklist', g => 'Guard Archive', 5 => 'Forward to Owner'
   );

   # Not the best way to do it ... see below :(
   print '<P><BIG><STRONG>List Options:</STRONG></BIG><TABLE BORDER="0" CELLPADDING="3"><TR><TD>';
   foreach $i ('a','d','f','g','i','k','l','m','n','p','q','r','s','t','u','5') {
      if ($DEFAULT_OPTIONS =~ /$i/) {
         print $q->checkbox(-name=>$i, -value=>$i, -label=>$labels{$i}, -on=>'1');
      } else {
         print $q->checkbox(-name=>$i, -value=>$i, -label=>$labels{$i});
      }
      print '</TD>'; $j++;
      if ($j >= 3) {
         $j = 0; print '</TR><TR>';
      }
      print '<TD>';
   }
   print '</TD></TR></TABLE>';

   
#  For some reason CGI.pm doesn't parse this properly ... any ideas why??
#  print $q->checkbox_group(-name=>'options',
#         -values=>['a','d','f','g','i','k','l','m','n','p','q','r','s','t','u'],
#         -default=>['a','i','p'], -labels=>\%labels, -columns=>'3');
   
   print '<P>', $q->submit(-name=>'action', -value=>'[Create List]'), ' ';
   print $q->reset(-value=>'[Reset Form]'), ' ';
   print $q->submit(-name=>'action', -value=>'[Cancel]');
   print $q->endform;  
   
}

# ------------------------------------------------------------------------

sub create_list {
   # Create a lista acording to user selections ...
   
   # Check the list directory exists and create if necessary ...
   if(!-e $LIST_DIR) {
      die "Unable to create directory: $!" unless mkdir $LIST_DIR, 0700;
   }
   
   my ($qmail, $list, $options, $i);
   
   # Some taint checking ...
   $qmail = $1 if $q->param('inlocal') =~ /-?([\w.+:]+)$/;
   $list = $q->param('list'); $list =~ s/ /_/; # In case some git tries to put a space in the file name

   # Sanity Checks ...
   return 1 if ($list eq '' || $qmail eq '');
   if(-e ("$LIST_DIR/$list/lock") || -e ("$HOME_DIR/.qmail-$qmail")) {
      print "<H1 ALIGN=CENTER>List '$list' already exists :(</H1>";
      return 1;
   }
  
   # Work out the command line options
   foreach $i ('a','d','f','g','i','k','l','m','n','p','q','r','s','t','u') {
      if (defined($q->param($i))) {
         $options .= $i;
      } else {
         $options .= uc($i);
      }
   }
   
   # Set owner if required ...
   if (defined($q->param('5'))) {
      $options .= "5 \'$USER\@$DEFAULT_HOST\'";
   }
   
   # Actually make the list ...
   system "ezmlm-make", "-x$options", "$LIST_DIR/$list", "$HOME_DIR/.qmail-$qmail", "$q->param('inlocal')", "$q->param('inhost')" ||
      die "List creation failed";
   
   # Handle the change to inlocal for virtual hosts ...
   if($q->param('inhost') ne $DEFAULT_HOST) {
      open(INLOCAL, ">$LIST_DIR/$list/inlocal") || die "Error reading inlocal: $!";
      print INLOCAL "$USER-" . $q->param('inlocal') . "\n";
      close INLOCAL;
   }

   return 0;
}

# ------------------------------------------------------------------------

sub list_config {
   # Allow user to alter the list configuration ...

   my ($list, $listaddress, $listname, $options, %labels);
   my ($headeradd, $headerremove, $mimeremove, $prefix, $j);
   
   # Store some variables before we delete them ...
   $list = $LIST_DIR . '/' . $q->param('list');
   $listname = $q->param('list');
   $listaddress = &this_listaddress;
                                   
   # Print a form of options ...
   $q->delete_all;
   print '<H2 ALIGN="center">Edit List Configuration</H2><HR ALIGN=center WIDTH=25%>';
   print $q->startform;
   print $q->hidden(-name=>'state', -value=>'configuration');
   print $q->hidden(-name=>'list', -value=>$listname);
   print "<BIG><STRONG>List name: <EM>$listname</EM><BR>";
   print "List address: <EM>$listaddress</EM></STRONG></BIG><P>";
   print '<BIG><STRONG>List Options</BIG></STRONG><BR>';
   
   # The labels to display against various ezmlm-make command line switches ...
   %labels = (
      a => 'Archived', d => 'Digest', f => 'Prefix', i => 'Indexed',
      l => 'Subscriber List', m => 'Moderated Posting', n => 'Text Editing',
      p => 'Public', r => 'Remote Admin', s => 'Moderated Subscription',
      t => 'Trailer', u => 'User Posting Only',q => 'Service Request Address',
      k => 'Blacklist', g => 'Guard Archive', 5 => 'Forward to Owner'
   );
   
   # Work out what options are already selected ...
   open(CONFIG, "<$list/config") || die "Unable to read DIR/config: $!. This probably means that your mailing list was created with an older version of ezmlm. Try recreating the list with the newer version. Died";
   while(<CONFIG>) {
      next unless /^F:-(\w+)/;
      $options = $1; last;
   }
   close CONFIG;

   # Print a list of options, selecting the ones that apply to this list ...
   print '<TABLE BORDER="0" CELLPADDING="3"><TR><TD>';
   foreach $i ('a','d','f','g','i','k','l','m','n','p','q','r','s','t','u','5') {
      if ($options =~ /$i/) {
         print $q->checkbox(-name=>$i, -value=>$i, -label=>$labels{$i}, -on=>'1');
      } else {
         print $q->checkbox(-name=>$i, -value=>$i, -label=>$labels{$i});
      }
      print '</TD>'; $j++;
      if ($j >= 3) {
         $j = 0; print '</TR><TR>';
      }
      print '<TD>';
   }
   print '</TD></TR></TABLE>';

   # Get the contents of the headeradd, headerremove, mimeremove and prefix files
   open(ADD, "<$list/headeradd") || die "Unable to read DIR/headeradd: $!";
   open(DEL, "<$list/headerremove") || die "Unable to read DIR/headerremove: $!";
   open(MIME, "<$list/mimeremove"); # no die since it may not exist.
   open(PREFIX, "<$list/prefix"); # ditto mimeremove
   while(<ADD>) { $headeradd .= $_; }
   while(<DEL>) { $headerremove .= $_; }
   while(<MIME>) { $mimeremove .= $_; }
   while(<PREFIX>) { $prefix .= $_; }
   close ADD, DEL, MIME, PREFIX;

   print '<P><BIG><STRONG>Subject prefex for outgoing messages: </STRONG></BIG>', $q->textfield(-name=>'prefix', -default=>$prefix, -size=>12) if defined($prefix);
   print '<P><BIG><STRONG>Headers to strip from all outgoing mail:</BIG></STRONG><BR>', $q->textarea(-name=>'headerremove', -default=>$headerremove, -rows=>5, -columns=>70);
   print '<P><BIG><STRONG>Headers to add to all outgoing mail:</BIG></STRONG><BR>', $q->textarea(-name=>'headeradd', -default=>$headeradd, -rows=>5, -columns=>70);
   print '<P><BIG><STRONG>Mime types to strip from all outgoing mail:</BIG></STRONG><BR>', $q->textarea(-name=>'mimeremove', -default=>$mimeremove, -rows=>5, -columns=>70) if defined($mimeremove);
   
   print '<P>', $q->submit(-name=>'action', -value=>'[Update Configuration]'), ' ';
   print $q->reset(-value=>'[Reset Form]'), ' ';
   print $q->submit(-name=>'action', -value=>'[Cancel]'), ' ';   
   print $q->submit(-name=>'action', -value=>'[Edit Texts]');
   print $q->endform;  

}

# ------------------------------------------------------------------------

sub update_config {
   # Save the new user entered config ...
   
   my ($list, $options, $i);
   $list = $LIST_DIR . '/' . $q->param('list');

   # Small sanity check ...
   if(!-e ("$list/lock")) {
      print "<H1 ALIGN=CENTER>Warning: Errors detected in list '$list'</H1>";
   }
  
   # Work out the command line options ...
   foreach $i ('a','d','f','g','i','k','l','m','n','p','q','r','s','t','u') {
      if (defined($q->param($i))) {
         $options .= $i;
      } else {
         $options .= uc($i);
      }
   }

   # Sort out owner
   if (defined($q->param('5'))) {
      $options .= "5 \'$USER\@$DEFAULT_HOST\'";
   }
   
   # Actually update the list ...
   system "ezmlm-make",  "-ex$options", "$list" || die "List update failed";

   # Update headeradd, headerremove, mimeremove and prefix ...
   open(ADD, ">$list/headeradd") || die "Unable to write DIR/headeradd: $!";
   open(DEL, ">$list/headerremove") || die "Unable to write DIR/headerremove: $!";
   (open(MIME, ">$list/mimeremove") || die "Unable to write DIR/mimeremove") if defined($q->param('mimeremove'));
   (open(PREFIX, ">$list/prefix") || die "Unable to write DIR/prefix") if defined($q->param('prefix'));
   print ADD $q->param('headeradd');
   print DEL $q->param('headerremove');
   print MIME $q->param('mimeremove') if defined($q->param('mimeremove'));
   print PREFIX $q->param('prefix') if defined($q->param('prefix'));
   close ADD, DEL, MIME, PREFIX;
   
}

# ------------------------------------------------------------------------

sub this_listaddress {
   # Work out the address of this list ... Used often so put in its own subroutine ...
   
   my ($list, $listaddress);
   $list = $LIST_DIR . '/' . $q->param('list');
   open(OUTLOCAL, "<$list/outlocal") || die "Unable to read DIR/outlocal: $!";
   chomp($listaddress = <OUTLOCAL>);
   $listaddress .= '@';
   open(OUTHOST, "<$list/outhost") || die "Unable to read DIR/outhost: $!";
   chomp($listaddress .= <OUTHOST>);
   close OUTHOST, OUTLOCAL;
   return $listaddress;
}

# ------------------------------------------------------------------------

sub blacklist {
   # Update the blacklist ...

   my ($i, $list, $listaddress, @subscribers);
   
   # Work out the address of this list ...
   $list = $LIST_DIR . '/' . $q->param('list');
   $listaddress = &this_listaddress;

   # Get blacklist from ezmlm ...
   @subscribers = sort `ezmlm-list $list/blacklist`;
   
   # Print out a form of options ...
   $q->delete('state');                     
   print "<H2 ALIGN=center>Blacklist for $listaddress</H2><HR ALIGN=center WIDTH=25%><P>";
   print $q->startform;
   print '<CENTER><TABLE ALIGN="center" BORDER="0" CELLPADDING="10"><TR><TD ROWSPAN="3" VALIGN="top" ALIGN="center">';
   print $q->hidden(-name=>'state', -default=>'blacklist');
   print $q->hidden(-name=>'list', -default=>$q->param('list')), "\n";
   print $q->scrolling_list(-name=>'delsubscriber', -values=>\@subscribers) if defined(@subscribers);
   print '</TD><TD VALIGN="top" ALIGN="left">';
   print $q->submit(-name=>'action', -value=>'[Delete Address]'), '<P>' if defined(@subscribers);
   print $q->textfield(-name=>'addsubscriber', -size=>'40'), '<BR>';
   print $q->submit(-name=>'action', -value=>'[Add Address]'), '<P>';
   print $q->submit(-name=>'action', -value=>'[Subscribers]');
   print '</TD></TR><TR><TD> </TD></TR></TABLE></CENTER>';
   print $q->endform;          

}

# ------------------------------------------------------------------------

sub list_text {
   # Show a listing of what is in DIR/text ...
   
   my(@files, $list);
   $list = $LIST_DIR . '/' . $q->param('list');

   # Read the list directory for text ...
   opendir DIR, "$list/text" || die "Unable to read DIR/text: $!";
   @files = grep !/^\./, readdir DIR; 
   closedir DIR;

   # Print a form ...
   $q->delete('state');
   print $q->startform;
   print $q->hidden(-name=>'state', -default=>'list_text');
   print $q->hidden(-name=>'list', -default=>$q->param('list'));
   print '<CENTER><TABLE BORDER="0" CELLPADDING="10" ALIGN="center"><TR><TD ALIGN="center" VALIGN="top" ROWSPAN="2">';
   print $q->scrolling_list(-name=>'file', -values=>\@files);
   print '</TD><TD ALIGN="center" VALIGN="top">';
   print $q->submit(-name=>'action', -value=>'[Edit File]'), ' ';
   print $q->submit(-name=>'action', -value=>'[Cancel]');
   print << 'EOM';
      <P>
      The box on the left contains a list of files available in the<BR>
      DIR/text directory. Thes files are sent out in response to<BR>
      specfic user request, or as part of all outgoing messages<P>
      To edit a file, select its name from the box. Then click on the<BR>
      [Edit File] button.<P>
      Press [Cancel] when you have finished editing. 
      </TD></TR><TR><TD> </TD></TR></TABLE></CENTER>
EOM
   print $q->endform;
   
}

# ------------------------------------------------------------------------

sub edit_text {
   # Allow user to edit the contents of DIR/text ...

   my ($file, $content);
   $file = $LIST_DIR . '/' . $q->param('list') . '/text/' . $q->param('file');

   # Read the current file ...
   open (FILE, "<$file") || die "Unable to read $file: $!";
   while (<FILE>) { $content .= $_; }
   close FILE;

   # Print a form ...
   $q->delete('state');
   print '<H2 ALIGN="CENTER">Editing file: ' . $q->param('file') . '</H2>';
   print '<CENTER><TABLE ALIGN="center" CELLPADDING="5"><TR><TD VALIGN="top" ROWSPAN="2">';
   print $q->startform;
   print $q->hidden(-name=>'state', -default=>'edit_text');
   print $q->hidden(-name=>'list', -default=>$q->param('list'));
   print $q->hidden(-name=>'file', -default=>$q->param('file'));
   print $q->textarea(-name=>'content', -default=>$content, -rows=>'25', -columns=>'72');
   print '</TD><TD VALIGN="top" ALIGN="left">';
   print $q->submit(-name=>'action', -value=>'[Save File]'), ' ';
   print $q->reset(-value=>'[Reset]'), ' ';
   print $q->submit(-name=>'action', -value=>'[Cancel]');
   print << 'EOM';
      <P><BIG><STRONG>ezmlm-manage</STRONG></BIG><BR>
      <TT><STRONG>&lt;#l#&gt;</STRONG></TT> The list name<BR>
      <TT><STRONG>&lt;#A#&gt;</STRONG></TT> The subscription address<BR>
      <TT><STRONG>&lt;#R#&gt;</STRONG></TT> The address a subscriber must reply to
      <P><BIG><STRONG>ezmlm-store</STRONG></BIG><BR>
      <TT><STRONG>&lt;#l#&gt;</STRONG></TT> The list name<BR>
      <TT><STRONG>&lt;#A#&gt;</STRONG></TT> The acceptance address<BR>
      <TT><STRONG>&lt;#R#&gt;</STRONG></TT> The rejection address
      </UL>
EOM
   print $q->endform;
   print '</TD></TR><TR><TD> <TD></TR></TABLE><CENTER>'

}
   
# ------------------------------------------------------------------------

sub save_text {
   # Save new text in DIR/text ...

   my ($file);
   $file = $LIST_DIR . '/' . $q->param('list') . '/text/' . $q->param('file');
   open (FILE, ">$file") || die "Unable to write $file: $!";
   print FILE $q->param('content');
   close FILE;
   
}   

# ------------------------------------------------------------------------

sub digest {
   # Allow user to edit digest subscribers ...

   my ($i, $list, $listaddress, @subscribers);
   
   # Work out the address of this list ...
   $list = $LIST_DIR . '/' . $q->param('list');
   $listaddress = &this_listaddress;

   # Get digest subscribers from ezmlm ...
   @subscribers = sort `ezmlm-list $list/digest`;
   
   # Print out a form of options ...
   $q->delete('state');                     
   print "<H2 ALIGN=center>Digest Subscribers for $listaddress</H2><HR ALIGN=center WIDTH=25%><P>";
   print $q->startform;
   print '<CENTER><TABLE ALIGN="center" BORDER="0" CELLPADDING="10"><TR><TD ROWSPAN="3" VALIGN="top" ALIGN="center">';
   print $q->hidden(-name=>'state', -default=>'digest');
   print $q->hidden(-name=>'list', -default=>$q->param('list')), "\n";
   print $q->scrolling_list(-name=>'delsubscriber', -values=>\@subscribers) if defined(@subscribers);
   print '</TD></TR><TR><TD VALIGN="top" ALIGN="left">';
   print $q->submit(-name=>'action', -value=>'[Delete Address]'), '<P>' if defined(@subscribers);
   print $q->textfield(-name=>'addsubscriber', -size=>'40'), '<BR>';
   print $q->submit(-name=>'action', -value=>'[Add Address]'), '<P>';
   print $q->submit(-name=>'action', -value=>'[Subscribers]');
   print '</TD></TR><TR><TD> </TD></TR></TABLE></CENTER>';
   print $q->endform;          

}

# ------------------------------------------------------------------------

sub create_config {
   # Try and write a config file for the list.
   # This is a HACK to allow owners of older lists to edit the list config :)
   
   my ($options, $list, $outlocal, $outhost); $list = $LIST_DIR . '/' . $q->param('list');

   $options = 'a' if (-e "$list/archived");
   $options .= 'd' if (-e "$list/digest");
   $options .= 'f' if (-e "$list/prefix");
   # g
   $options .= 'i' if (-e "$list/indexed");
   $options .= 'k' if (-e "$list/blacklist");
   # l
   $options .= 'm' if (-e "$list/modpost");
   # n
   $options .= 'p' if (-e "$list/public");
   # q
   $options .= 'r' if (-e "$list/remote");
   $options .= 's' if (-e "$list/modsub");
   # t
   # u

   open(OUTLOCAL, "<$list/outlocal") || die "Unable to read DIR/outlocal: $!";
   chomp($outlocal = <OUTLOCAL>);
   open(OUTHOST, "<$list/outhost") || die "Unable to read DIR/outhost: $!";
   chomp($outhost .= <OUTHOST>);
   close OUTHOST, OUTLOCAL;
   
   open(CONFIG, ">$list/config") || die "Unable to write config file";
   print CONFIG "F:-$options\n";
   print CONFIG "D:$lists\n";
   print CONFIG "T:$HOME_DIR/.qmail-$outlocal\n";
   print CONFIG "L:$outlocal\n";
   print CONFIG "h:$outhost\n";
   print CONFIG "C:\n";
   print CONFIG "0:\n";
   print CONFIG "1:\n";
   print CONFIG "2:\n";
   print CONFIG "3:\n";
   print CONFIG "4:\n";
   print CONFIG "5:\n";
   print CONFIG "6:\n";
   print CONFIG "7:\n";
   print CONFIG "8:\n";
   print CONFIG "9:\n";

   close CONFIG;

   print '<H2 ALIGN=CENTER>Config File Created</H2>';
   print '<CENTER>Note that not all options may have been successfully determined</CENTER><P>';

}

# ------------------------------------------------------------------------
# End of ezmlm-web.cgi v1.0
# ------------------------------------------------------------------------
